﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=8.1
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Private mnForm As Form
	Private lbFuente, lbTam, lbEst, lbCol, lbEj, lbTexto As Label
	Private lvFuente, lvTam As ListView
	Private chkNeg, chkCur As CheckBox
	Private pnCol, pnEst, pnEj As Pane
	Private btAcep, btCan As Button
	Private colPick As ColorPicker
	Private cancelar As Boolean
End Sub

Private Sub CrearVentana
	mnForm.Initialize("mnForm",385,440)
	mnForm.SetFormStyle("UTILITY")
	mnForm.Resizable=False
	mnForm.Title="Font"

	lbFuente.Initialize("lbFuente")
	lbFuente.Text="Font"
	lbFuente.TextSize=16
	lbFuente.Alignment="TOP_LEFT"
	
	lvFuente.Initialize("lvFuente")
	CSSUtils.SetStyleProperty(lvFuente,"-fx-font-size","16")
	lvFuente.Items.AddAll(fx.GetAllFontFamilies)
	
	lbTam.Initialize("lbTam")
	lbTam.Text="Size"
	lbTam.TextSize=16
	lbTam.Alignment="TOP_LEFT"
	
	lvTam.Initialize("lvTam")
	CSSUtils.SetStyleProperty(lvTam,"-fx-font-size","16")
	For i=8 To 72
		lvTam.Items.Add(i)
	Next
	
	lbCol.Initialize("lbCol")
	lbCol.Text="Color"
	lbCol.TextSize=16
	lbCol.Alignment="TOP_LEFT"
	
	pnCol.Initialize("pnCol")
	CSSUtils.SetBorder(pnCol,0.1,fx.Colors.Black,0)
	colPick.Initialize("colPick")
	pnCol.AddNode(colPick,7,7,185,50)
	
	lbEst.Initialize("lbEst")
	lbEst.Text="Style"
	lbEst.TextSize=16
	lbEst.Alignment="TOP_LEFT"
	
	chkNeg.Initialize("chkNeg")
	chkNeg.Text="Bold"
	chkNeg.TextSize=16
	chkNeg.Alignment="TOP_LEFT"
	
	chkCur.Initialize("chkCur")
	chkCur.Text="Italic"
	chkCur.TextSize=16
	chkCur.Alignment="TOP_LEFT"
	
	pnEst.Initialize("pnEST")
	CSSUtils.SetBorder(pnEst,0.1,fx.Colors.Black,0)
	pnEst.AddNode(chkNeg,10,7,100,30)
	pnEst.AddNode(chkCur,10,35,100,30)
	
	lbEj.Initialize("lbEj")
	lbEj.Text="Sample"
	lbEj.TextSize=16
	lbEj.Alignment="TOP_LEFT"
	
	lbTexto.Initialize("lbTexto")
	 
	lbTexto.Text="For God so loved the world, that he gave his only begotten Son, " & _
	 "that whosoever believeth in him should Not perish, but have everlasting life. John 3:16"
	lbTexto.TextSize=14
	lbTexto.Alignment="TOP_LEFT"
	lbTexto.WrapText=True
	
	pnEj.Initialize("pnEj")
	CSSUtils.SetBackgroundColor(pnEj,fx.Colors.From32Bit(0xFFFFFFFF))
	CSSUtils.SetBorder(pnEj,0.1,fx.Colors.Black,0)
	pnEj.AddNode(lbTexto,10,05,345,65)
	
	btCan.Initialize("btCan")
	btCan.Text="Cancel"
	Dim jo As JavaObject=btCan
	jo.RunMethod("setCancelButton",Array(True))
	
	btAcep.Initialize("btAcep")
	btAcep.Text="OK"
	jo=btAcep
	jo.RunMethod("setDefaultButton",Array(True))
	
	mnForm.RootPane.AddNode(lbFuente,10,05,200,30)
	mnForm.RootPane.AddNode(lvFuente,10,30,200,150)
	mnForm.RootPane.AddNode(lbTam,225,05,200,30)
	mnForm.RootPane.AddNode(lvTam,225,30,150,150)
	mnForm.RootPane.AddNode(pnCol,10,215,200,65)
	mnForm.RootPane.AddNode(lbCol,10,190,200,30)
	mnForm.RootPane.AddNode(pnEst,225,215,150,65)
	mnForm.RootPane.AddNode(lbEst,225,190,100,30)
	mnForm.RootPane.AddNode(pnEj,10,315,365,75)
	mnForm.RootPane.AddNode(lbEj,10,290,200,30)
	mnForm.RootPane.AddNode(btCan,205,400,80,30)
	mnForm.RootPane.AddNode(btAcep,295,400,80,30)

	btAcep.RequestFocus
	
End Sub

'Returns a list with two values.
'The first value: list(0) is a font object.
'The second value: list(1) is a color object.
'If the dialog box is canceled then it returns null.
'<code>
'Dim obj As Object= FontPicker.Show(fx.CreateFont("Consolas", 15, True, False), 0xFFDC143C)
'	If obj=Null Then
'		fx.Msgbox(MainForm, "*** User canceled dialog box ***", "FontPicker")
'	Else
'		Dim listFont As List=obj
'		Dim font As Font= listFont.Get(0)
'		fx.Msgbox(MainForm,"FONT: " & font & CRLF & CRLF & "COLOR: " & listFont.Get(1), "FontPicker")
'	End If
'</code>
Public Sub Show(DefaultFont As Font, DefaultColor As Int) As Object
	Dim mapa As Map

	CrearVentana
	EstablecerFuente(DefaultFont,DefaultColor)
	mnForm.ShowAndWait
	
	If cancelar=False Then
		mapa.Initialize
		mapa.Put("font",fx.CreateFont(lvFuente.SelectedItem,lvTam.SelectedItem,chkNeg.Checked,chkCur.Checked))
		mapa.Put("color",colPick.SelectedColor)
		Return mapa
	Else
		Return Null
	End If
	
End Sub

Private Sub EstablecerFuente(Fuente As Font, Color As Int)
	Dim tipoFuente() As String
	Dim fnt As String
	Dim indice, tam As Int
	
	tipoFuente= Regex.Split(",",Fuente)
	fnt=tipoFuente(1).SubString(tipoFuente(1).IndexOf("=")+1).Trim
	
	indice=lvFuente.Items.IndexOf(fnt)
	If indice<>-1 Then
		lvFuente.SelectedIndex=indice
		lvFuente.ScrollTo(indice)
	Else
		lvFuente.SelectedIndex=0
		lvFuente.ScrollTo(0)
	End If
	
	tam=Fuente.Size
	indice=lvTam.Items.IndexOf(tam)
	If indice<>-1 Then
		lvTam.SelectedIndex=indice
		lvTam.ScrollTo(indice)
	Else
		lvTam.SelectedIndex=0
		lvTam.ScrollTo(0)
	End If
	
	chkNeg.Checked=tipoFuente(2).Contains("Bold")
	chkCur.Checked=tipoFuente(2).Contains("Italic")
	
	colPick.SelectedColor=fx.Colors.From32Bit(Color)
	
	ActualizarFuente
End Sub

Private Sub ActualizarFuente
	lbTexto.Font=fx.CreateFont(lvFuente.SelectedItem,lvTam.SelectedItem,chkNeg.Checked,chkCur.Checked)
	lbTexto.TextColor=colPick.SelectedColor
End Sub

Private Sub lvFuente_SelectedIndexChanged(Index As Int)
	ActualizarFuente
End Sub

Private Sub lvTam_SelectedIndexChanged(Index As Int)
	ActualizarFuente
End Sub

Private Sub colPick_ValueChanged (Value As Paint)
	ActualizarFuente
End Sub

Private Sub chkNeg_CheckedChange(Checked As Boolean)
	ActualizarFuente
End Sub

Private Sub chkCur_CheckedChange(Checked As Boolean)
	ActualizarFuente
End Sub

Private Sub btCan_Click
	cancelar=True
	mnForm.Close
End Sub

Private Sub btAcep_Click
	cancelar=False
	mnForm.Close
End Sub

Private Sub mnForm_CloseRequest (EventData As Event)
	cancelar=True
End Sub
